Subject: Re: [dtn-users] TCPCL keepalive interval
From: Michael Demmer <[email-masked]>
To: Teemu <[email-masked]>
Cc: [email-masked]
Date: Mon, 27 Apr 2009 08:49:29 -0700
List-Id: dtn-users mailing list <dtn-users.maillists.intel-research.net>

I'm too far removed from the code to know why you're having the specific
problem, but one reason why you might be seeing it intermittently is that
there's a race between the two hosts to see which one establishes the TCP
connection first, if you've configured a link on both sides.

Other than that my guess is that this is a simple bug in the logic for
setting up the various timers in the connection-oriented convergence layer
and that the case in which one side wants keepalives but the other doesn't
was simply not very well tested.

-m

On Mon, Apr 27, 2009 at 4:14 AM, Teemu <[email-masked]> wrote:

> Hi,
>
> We're running into a randomly occurring problem where the TCPCL of DTN2 is
> requesting a keepalive interval of 0 (i.e., to disable keepalives) in the
> contact header. If we then do not send keepalives as requested, DTN2 will
> timeout the connection due to inactivity after 2x the timeout we requested.
>
> According to draft-irtf-dtnrg-tcp-clayer-02:
>
>        The keepalive_interval parameter is set to the minimum value
>        from both contact headers.  If one or both contact headers
>        contains the value zero, then the keepalive feature (described
>        in Section 5.5) is disabled.
>
> However, it seems like DTN2 is expecting keepalives at the interval we
> request in the contact header instead of disabling the feature as per the
> above spec. Also, DTN2 will not send any keepalives in this case.
>
> This issue seems to occur and disappear unpredictably with both 2.6 release
> and the current repository version. Restarting the dtnd instance or
> changing
> to a different version sometimes fixes this, but not always.
>
> Any insights on what might be going on?
>
> Cheers,
> -Teemu
>
>
> _______________________________________________
> dtn-users mailing list
> [email-masked]
> http://maillists.intel-research.net/mailman/listinfo/dtn-users
>